> ## Documentation Index
> Fetch the complete documentation index at: https://developers.myhero.so/llms.txt
> Use this file to discover all available pages before exploring further.

# Update a column

> Updates a column's `name`, `description`, data `type`, or type-specific options (`number`, `oneMany`, `selectItems`).

When renaming, all table references that display this column's name are updated automatically.

Returns 409 on a duplicate name within the same table.



## OpenAPI

````yaml put /table/column/{columnId}
openapi: 3.1.0
info:
  title: HERO API
  version: current
  description: |-
    The HERO REST API.

    See https://developers.myhero.so for the rendered docs.
servers:
  - url: https://app.myhero.so
security: []
paths:
  /table/column/{columnId}:
    put:
      tags:
        - Tables
      summary: Update a column
      description: >-
        Updates a column's `name`, `description`, data `type`, or type-specific
        options (`number`, `oneMany`, `selectItems`).


        When renaming, all table references that display this column's name are
        updated automatically.


        Returns 409 on a duplicate name within the same table.
      operationId: updateColumn
      parameters:
        - schema:
            type: string
            minLength: 1
          required: true
          name: columnId
          in: path
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                name:
                  type: string
                description:
                  type: string
                type:
                  type: string
                  enum:
                    - identifier
                    - oneMany
                    - string
                    - number
                    - money
                    - time
                    - location
                    - date
                    - checkbox
                    - formula
                    - select
                    - multiSelect
                    - linkCell
                    - email
                    - url
                    - phone
                    - image
                number:
                  type: object
                  properties:
                    format:
                      type: string
                    decimalPlaces:
                      type: number
                    aggregation:
                      type:
                        - string
                        - 'null'
                      enum:
                        - sum
                        - avg
                        - min
                        - max
                        - null
                oneMany:
                  type: object
                  properties:
                    tableId:
                      type: string
                selectItems:
                  type: array
                  items:
                    type: object
                    properties:
                      id:
                        type: string
                      label:
                        type: string
                      color:
                        type: string
                    required:
                      - id
                      - label
                      - color
      responses:
        '200':
          description: 200 response
          content:
            application/json:
              schema:
                type: object
                properties:
                  data:
                    type: object
                    properties:
                      _id:
                        type: string
                      originId:
                        type: string
                      projectId:
                        type: string
                      tableId:
                        type: string
                      workspaceId:
                        type: string
                      isIdentifier:
                        type: boolean
                        example: false
                      name:
                        type: string
                      slug:
                        type: string
                      description:
                        type: string
                      data:
                        type: object
                        properties:
                          type:
                            type: string
                            enum:
                              - identifier
                              - oneMany
                              - string
                              - number
                              - money
                              - time
                              - location
                              - date
                              - checkbox
                              - formula
                              - select
                              - multiSelect
                              - linkCell
                              - email
                              - url
                              - phone
                              - image
                          selectItems:
                            type: array
                            items:
                              type: object
                              properties:
                                id:
                                  type: string
                                label:
                                  type: string
                                color:
                                  type: string
                              required:
                                - id
                                - label
                                - color
                          number:
                            type: object
                            properties:
                              format:
                                type: string
                              decimalPlaces:
                                type: number
                              aggregation:
                                type:
                                  - string
                                  - 'null'
                                enum:
                                  - sum
                                  - avg
                                  - min
                                  - max
                                  - null
                          oneMany:
                            type: object
                            properties:
                              tableId:
                                type: string
                        required:
                          - type
                          - selectItems
                      createdAt:
                        type: number
                      updatedAt:
                        type: number
                      isDeleted:
                        type: boolean
                        example: false
                    required:
                      - _id
                      - projectId
                      - tableId
                      - workspaceId
                      - isIdentifier
                      - name
                      - slug
                      - data
                      - createdAt
                      - updatedAt
                required:
                  - data
        '400':
          description: 400 response
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: string
                    description: |-
                      Error class name (e.g.

                      ValidationError, NotFound)
                  message:
                    type: string
                    description: Human-readable error message
                  details:
                    type: array
                    items: {}
                required:
                  - error
                  - message
        '403':
          description: 403 response
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: string
                    description: |-
                      Error class name (e.g.

                      ValidationError, NotFound)
                  message:
                    type: string
                    description: Human-readable error message
                  details:
                    type: array
                    items: {}
                required:
                  - error
                  - message
        '404':
          description: 404 response
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: string
                    description: |-
                      Error class name (e.g.

                      ValidationError, NotFound)
                  message:
                    type: string
                    description: Human-readable error message
                  details:
                    type: array
                    items: {}
                required:
                  - error
                  - message
        '409':
          description: 409 response
          content:
            application/json:
              schema:
                type: object
                properties:
                  message:
                    type: string
                  type:
                    type: string
                    enum:
                      - COLUMN_NAME_CONFLICT
                required:
                  - message
                  - type
      security:
        - bearerAuth: []
components:
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer
      description: HERO personal access token

````